package com.example.trial.lovers.resource;

import org.springframework.beans.factory.annotation.Autowired;

import com.example.trial.lovers.bdd.Lover;
import com.example.trial.lovers.bdd.LoverRepository;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Path("lovers")
public class LoverResource {
    @Autowired
    public LoverRepository loverRepository;

    @GET
    @Produces(MediaType.APPLICATION_JSON)
    public List<Lover> listerLovers() {
        List<Lover> lovers = new ArrayList<>();
        loverRepository.findAll().forEach(lovers::add);
        return lovers;
    }

    @POST
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Lover creerLover(Lover l) {
        return loverRepository.save(l);
    }

    @DELETE
    @Path("{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public Response deleteLover(@PathParam("id") Long id) {
        if (loverRepository.findById(id).isPresent()) {
            try {
                loverRepository.deleteById(id);
            } catch (Exception e) {
                return Response.serverError().build();
            }
        }
        return Response.noContent().build();
    }
    
    @PATCH
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	@Path("{id}")
	// PATCH /lovers/{id}
	public Response updatePartnerGender(@PathParam("id") Long id, Lover l) {
		String partnerGender = l.getPartnerGender();
		Optional<Lover> optional = loverRepository.findById(id);

		if (optional.isPresent()) {
			Lover lBDD = optional.get();
			lBDD.setPartnerGender(partnerGender);
			loverRepository.save(lBDD);
			return Response.ok(lBDD).build();
		} else {
			return Response.status(Response.Status.NOT_FOUND).build();
		}
	}
    public Response updatePartnerPet(@PathParam("id") Long id, Lover l) {
		String partnerPet = l.getPartnerPet();
		Optional<Lover> optional = loverRepository.findById(id);

		if (optional.isPresent()) {
			Lover lBDD = optional.get();
			lBDD.setPartnerGender(partnerPet);
			loverRepository.save(lBDD);
			return Response.ok(lBDD).build();
		} else {
			return Response.status(Response.Status.NOT_FOUND).build();
		}
	}
}
