package com.example.trial.profile.process;

import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

public interface ProfileRepository extends CrudRepository<Profile, Long> {

	Optional<Profile> findByFirstname(String firstname);
	
	Optional<Profile> findById(Long id);
	
	@Query("SELECT p from Profile p where p.id = :id")
	List<Profile> getProfileById(@Param("id") Long id);
	
	List<Profile> findByAge(int age);
	
	List<Profile> findByGenderAndPet(String gender, String pet);
}